import QtQuick 2.15
import QtQuick.Window 2.15
import QtQml 2.15

Window {
    width: 1920
    height: 720
    visible: true
    title: qsTr("Loader test")

    Loader {
        id: outerLoader

        width: 300
        height: 300

        state: "red"
        sourceComponent: red

        states: [
            State {
                name: "red"
                PropertyChanges {
                    target: outerLoader
                    sourceComponent: red
                }
            },
            State {
                name: "blue"
                PropertyChanges {
                    target: outerLoader
                    sourceComponent: blue
                }
            }
        ]
    }

    Timer {
        interval: 3000
        running: true
        repeat: true
        onTriggered: outerLoader.state = (outerLoader.state === "red") ? "blue" : "red"
    }

    Component {
        id: red

        Rectangle {
            color: "red"

            Loader {
                id: innerLoader

                width: 150
                height: 150
                anchors.centerIn: parent

                state: "green"
                sourceComponent: green

                states: [
                    State {
                        name: "green"
                        PropertyChanges {
                            target: innerLoader
                            sourceComponent: green
                        }
                    },
                    State {
                        name: "magenta"
                        PropertyChanges {
                            target: innerLoader
                            sourceComponent: magenta
                        }
                    }
                ]
            }

            Timer {
                interval: 500
                running: true
                repeat: true
                onTriggered: innerLoader.state = (innerLoader.state === "green") ? "magenta" : "green"
            }
        }
    }

    Component {
        id: green

        Rectangle {
            color: "green"
            width: 200
            height: 200
        }
    }

    Component {
        id: magenta

        Rectangle {
            color: "magenta"
            width: 200
            height: 200
        }
    }

    Component {
        id: blue

        Rectangle {
            color: "blue"

            Loader {
                id: innerLoader

                width: 150
                height: 150
                anchors.centerIn: parent

                state: "cyan"
                sourceComponent: cyan

                states: [
                    State {
                        name: "cyan"
                        PropertyChanges {
                            target: innerLoader
                            sourceComponent: cyan
                        }
                    },
                    State {
                        name: "yellow"
                        PropertyChanges {
                            target: innerLoader
                            sourceComponent: yellow
                        }
                    }
                ]
            }

            Timer {
                interval: 500
                running: true
                repeat: true
                onTriggered: innerLoader.state = (innerLoader.state === "cyan") ? "yellow" : "cyan"
            }
        }
    }

    Component {
        id: cyan

        Rectangle {
            color: "cyan"
            width: 200
            height: 200
        }
    }

    Component {
        id: yellow

        Rectangle {
            color: "yellow"
            width: 200
            height: 200
        }
    }
}
